//
//  ICDeepLink.h
//  ICDeepLink
//
//  Created by kirill on 12/10/19.
//  Copyright © 2019 Inspector Cloud. All rights reserved.
//

#import <Foundation/Foundation.h>

//! Project version number for ICDeepLink.
FOUNDATION_EXPORT double ICDeepLinkVersionNumber;

//! Project version string for ICDeepLink.
FOUNDATION_EXPORT const unsigned char ICDeepLinkVersionString[];

// In this header, you should import all the public headers of your framework using statements like #import <ICDeepLink/PublicHeader.h>

@protocol ICDeepLinkDelegate <NSObject>

- (void)reciveVisitId:(NSString *_Nonnull)visitId customerId:(NSString *_Nonnull)customerId userInfo:(NSDictionary * _Nonnull)userInfo;
- (void)syncStatus:(BOOL)status withErrorCode:(NSNumber * _Nullable)errorCode;

@end


@interface ICDeepLink : NSObject

+ (instancetype _Nonnull)shared;

@property (nonatomic, weak) id<ICDeepLinkDelegate> _Nullable delegate;

@property (nonatomic, strong, nullable) NSString *scheme;
@property (nonatomic, strong, nullable) NSString *token;
@property (nonatomic, strong, nullable) NSString *agentId;

- (void)openVisitId:(NSString *_Nonnull)visitId
     withCustomerId:(NSString *_Nonnull)customerId
         withFilter:(NSString *_Nullable)filter
       withReadonly:(BOOL)readonly;

- (void)startSyncWithListCustomerId:(NSArray<NSString *> *_Nonnull)listCustomerId;

- (void)startSyncListCustomerId:(NSArray<NSString *> *_Nonnull)listCustomerId;

- (BOOL)proceedDeeplink:(NSURL *_Nonnull)url;

@end
