# ICDeepLink 1.0.5

Библиотека по работе с визитами в приложении IC Camera


## Установка


Для установки, файл **ICDeepLink.framework** в проект.

## Настройка

Для начала работы вам необходимо настроить несколько параметров:

**scheme** - схема нужна для того чтобы можно было вернуться в паше приложение. Для этого добавьте новую схему в разделе **URL Types** и после выполните следующий код: 

    [ICDeepLink shared].scheme = @"string";

**token** - токен необходим для доступа в приложение IC Camera для того чтобы начать визит.

    [ICDeepLink shared].token = @"string";

**agentId** - id пользователя необходим для идентификации в системе.

    [ICDeepLink shared].agentId = @"string";

### Синхронизация мастер-данных

При необходимости работы в оффлайн режиме, необходимо выполнить команду синхронизации. Мы рекомендуем проводить синхронизацию раз в день в начале дня в условиях хорошего подключения к Интернет. Для вызова синхронизации, необходимо указать список магазинов, пример вызова:
```objc
[[ICDeepLink shared] startSyncListCustomerId:@[@"id1", @"id2", @"id3"]];
``` 

После завершения синхронизации, происходит передача управления из приложения Inspector Cloud обратно в вызывающее приложение. Вызывающее приложение получает статус синхронизации в методе делегата и код ошибки, если она прошла не успешно:
```objc
- (void)syncStatus:(BOOL)status withErrorCode:(NSNumber * _Nullable)errorCode;
``` 

**status** - статус синхронизации. если status YES, тогда синхронизация прошла успешно, а если NO - возникла проблема синхронизации. В этом случае нужно сделать повторную попытку синхронизации
**errorCode** - код ошибки. если синхронизация прошла не успешно, будет передан код ошибки

### Переход в приложение Inspector Cloud

Для начала или просмотра визита, необходимо вызвать функцию

```objc
- (void)openVisitId:(NSString *_Nonnull)visitId
     withCustomerId:(NSString *_Nonnull)customerId
         withFilter:(NSString *_Nullable)filter
       withReadonly:(BOOL)readonly;
```

- **visitId** - id визита
- **customerId** - id точки в которой вы хотите сделать визит
- **filter** - фильтр задач (необязательно). Регулярное выражение ([описание](https://developer.android.com/reference/java/util/regex/Pattern)) для фильтрации задач по названию. Если задан фильтр, то визит будет отображать только задачи удовлетворяющие заданному фильтру.
- **readonly** - задает режим открытия визита только для чтения. В таком режиме задачи доступны только для просмотра

### Обработка входящих ссылок

При закрытии визита в приложении, происходит перебрасывание из приложение **IC Camera** в то приложение, из которого был начат этот визит. Для обработки ссылок, вызовете эту функцию:

    - (BOOL)application:(UIApplication *)app
                openURL:(NSURL *)url
                options:(NSDictionary<UIApplicationOpenURLOptionsKey, id> *)options {
        return [[ICDeepLink shared] proceedDeeplink:url];
    }

Чтобы получить информацию о визите и точке в которой был выполнен визит в **IC Camera**, вам необходимо подписаться на делегат **ICDeepLinkDelegate**

    [ICDeepLink shared].delegate = self;

и тогда метод

    - (void)reciveVisitId:(NSString *_Nonnull)visitId customerId:(NSString *_Nonnull)customerId userInfo:(NSDictionary * _Nonnull)userInfo

будет вызван, когда вы вернетесь в ваше приложение.
